// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Utilities/LinearAlgebra/Type.hpp"

#include "OperatorInstances/HyperelasticLaws/ExponentialJ1J4.hpp"

#include "Test/Operators/VariationalInstances/HyperelasticOperator/ExpectedResults.hpp"
#include "Test/Operators/VariationalInstances/HyperelasticOperator/ModelSettings.hpp"

// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

namespace MoReFEM::TestNS::HyperelasticOperatorNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP1P1<HyperelasticLawNS::ExponentialJ1J4<time_manager_type>>()
    {
        return expected_results_type<LinearAlgebraNS::type::matrix>{ { 2.9551456990818434e+09,
                                                                       -2.5868556818891735e+09,
                                                                       -7.7781761840106239e+09,
                                                                       -9.2988567058200703e+09,
                                                                       3.4829468813551702e+09,
                                                                       5.8021970552821913e+09,
                                                                       2.8600307614864421e+09,
                                                                       -5.9326987592008801e+09,
                                                                       5.8488914099460573e+09,
                                                                       3.4836802452517853e+09,
                                                                       5.0366075597348833e+09,
                                                                       -3.8729122812176275e+09 },
                                                                     { -2.5868556818891521e+09,
                                                                       3.2903540799459734e+09,
                                                                       8.4659740437534723e+09,
                                                                       1.0322046714292559e+10,
                                                                       -4.4911222443303652e+09,
                                                                       -6.5107513132432623e+09,
                                                                       -4.1175482043923321e+09,
                                                                       7.0719306516688719e+09,
                                                                       -6.6240959983654089e+09,
                                                                       -3.6176428280110788e+09,
                                                                       -5.8711624872844772e+09,
                                                                       4.6688732678552008e+09 },
                                                                     { -7.7781761840106544e+09,
                                                                       8.4659740437533951e+09,
                                                                       2.5061220500395855e+10,
                                                                       2.8636419104942463e+10,
                                                                       -1.2538154224733688e+10,
                                                                       -1.8364228183078274e+10,
                                                                       -8.8321583848776703e+09,
                                                                       2.0924125257999161e+10,
                                                                       -2.0367376978449696e+10,
                                                                       -1.2026084536054140e+10,
                                                                       -1.6851945077018856e+10,
                                                                       1.3670384661132109e+10 },
                                                                     { -9.2988567058200722e+09,
                                                                       1.0322046714292559e+10,
                                                                       2.8636419104942474e+10,
                                                                       3.3463969266861610e+10,
                                                                       -1.4914324927264235e+10,
                                                                       -2.1215275081101093e+10,
                                                                       -1.0925799307020958e+10,
                                                                       2.3543685208374210e+10,
                                                                       -2.2644415143420139e+10,
                                                                       -1.3239313254020575e+10,
                                                                       -1.8951406995402542e+10,
                                                                       1.5223271119578764e+10 },
                                                                     { 3.4829468813551617e+09,
                                                                       -4.4911222443303661e+09,
                                                                       -1.2538154224733700e+10,
                                                                       -1.4914324927264229e+10,
                                                                       6.7939819645749912e+09,
                                                                       9.4964739810276680e+09,
                                                                       6.0858218356608057e+09,
                                                                       -1.1056693348914127e+10,
                                                                       9.6514000152388115e+09,
                                                                       5.3455562102482557e+09,
                                                                       8.7538336286695004e+09,
                                                                       -6.6097197715327816e+09 },
                                                                     { 5.8021970552821960e+09,
                                                                       -6.5107513132432442e+09,
                                                                       -1.8364228183078270e+10,
                                                                       -2.1215275081101089e+10,
                                                                       9.4964739810276642e+09,
                                                                       1.3623665984743734e+10,
                                                                       6.0788759644262314e+09,
                                                                       -1.4845779120295149e+10,
                                                                       1.4982685555736626e+10,
                                                                       9.3342020613926659e+09,
                                                                       1.1860056452510723e+10,
                                                                       -1.0242123357402098e+10 },
                                                                     { 2.8600307614864397e+09,
                                                                       -4.1175482043923135e+09,
                                                                       -8.8321583848777027e+09,
                                                                       -1.0925799307020960e+10,
                                                                       6.0858218356608057e+09,
                                                                       6.0788759644262428e+09,
                                                                       3.7096565417264462e+09,
                                                                       -8.0962763291752520e+09,
                                                                       7.7253645336681013e+09,
                                                                       4.3561120038080778e+09,
                                                                       6.1280026979067602e+09,
                                                                       -4.9720821132166433e+09 },
                                                                     { -5.9326987592009077e+09,
                                                                       7.0719306516688595e+09,
                                                                       2.0924125257999096e+10,
                                                                       2.3543685208374199e+10,
                                                                       -1.1056693348914129e+10,
                                                                       -1.4845779120295122e+10,
                                                                       -8.0962763291752214e+09,
                                                                       1.8466271252591286e+10,
                                                                       -1.7441016598745991e+10,
                                                                       -9.5147101199980755e+09,
                                                                       -1.4481508555346014e+10,
                                                                       1.1362670461042015e+10 },
                                                                     { 5.8488914099460726e+09,
                                                                       -6.6240959983653698e+09,
                                                                       -2.0367376978449703e+10,
                                                                       -2.2644415143420155e+10,
                                                                       9.6514000152387981e+09,
                                                                       1.4982685555736626e+10,
                                                                       7.7253645336681013e+09,
                                                                       -1.7441016598746010e+10,
                                                                       1.6738296349996799e+10,
                                                                       9.0701591998059731e+09,
                                                                       1.4413712581872576e+10,
                                                                       -1.1353604927283733e+10 },
                                                                     { 3.4836802452517886e+09,
                                                                       -3.6176428280110707e+09,
                                                                       -1.2026084536054148e+10,
                                                                       -1.3239313254020571e+10,
                                                                       5.3455562102482595e+09,
                                                                       9.3342020613926640e+09,
                                                                       4.3561120038080692e+09,
                                                                       -9.5147101199980850e+09,
                                                                       9.0701591998059750e+09,
                                                                       5.3995210049607162e+09,
                                                                       7.7867967377608995e+09,
                                                                       -6.3782767251444893e+09 },
                                                                     { 5.0366075597348995e+09,
                                                                       -5.8711624872844706e+09,
                                                                       -1.6851945077018873e+10,
                                                                       -1.8951406995402542e+10,
                                                                       8.7538336286695023e+09,
                                                                       1.1860056452510721e+10,
                                                                       6.1280026979067459e+09,
                                                                       -1.4481508555346035e+10,
                                                                       1.4413712581872581e+10,
                                                                       7.7867967377608986e+09,
                                                                       1.1598837413961002e+10,
                                                                       -9.4218239573644295e+09 },
                                                                     { -3.8729122812176142e+09,
                                                                       4.6688732678552198e+09,
                                                                       1.3670384661132107e+10,
                                                                       1.5223271119578777e+10,
                                                                       -6.6097197715327778e+09,
                                                                       -1.0242123357402088e+10,
                                                                       -4.9720821132166595e+09,
                                                                       1.1362670461042000e+10,
                                                                       -1.1353604927283737e+10,
                                                                       -6.3782767251445026e+09,
                                                                       -9.4218239573644428e+09,
                                                                       7.9253436235537167e+09 } };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP1P1<HyperelasticLawNS::ExponentialJ1J4<time_manager_type>>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{
            399446544.71407926, -483837549.54864717, -1367154389.49915, -1549655444.2508564,
            701107752.2254114,  995535811.045055,    518931428.4539212, -1142975677.7817981,
            1107787491.2957428, 631277471.0828556,   925705475.1050342, -736168912.8416482
        };
    }


} // namespace MoReFEM::TestNS::HyperelasticOperatorNS

// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
